Name:           virtiofsd
Version:        1.1.0
Release:        4%{?dist}
Summary:        Virtio-fs vhost-user device daemon (Rust version)

# Upstream license specification: Apache-2.0 AND BSD-3-Clause
License:        ASL 2.0 and BSD
URL:            https://gitlab.com/virtio-fs/virtiofsd
Source0:        %{crates_source}
Source1:        %{name}-%{version}-vendor.tar.gz

# For bz#2057252 - process_queue_pool: Only acquire the VringMutex lock once
Patch1:         process_queue_pool-Only-acquire-the-VringMutex-lock-.patch
# For bz#2057252 - Set the number of written bytes for used descs
Patch2:         Set-the-number-of-written-bytes-for-used-descs.patch
# For bz#2057252 - Clean up flags in opendir (downstream)
Patch3:         Clean-up-flags-in-opendir-downstream.patch

ExclusiveArch:  x86_64 aarch64 s390x
BuildRequires:  rust-toolset
BuildRequires:  libcap-ng-devel
BuildRequires:  libseccomp-devel
Provides: virtiofsd
Obsoletes: qemu-virtiofsd = 17:6.2.0
# Both qemu-virtiofsd and virtiofsd ship the same binary
Conflicts: qemu-virtiofsd = 17:6.2.0

%description
%{summary}.

%prep
%setup -q -n %{name}-%{version}
%autopatch -p1

%cargo_prep -V 1

%build
%cargo_build

%install
mkdir -p %{buildroot}%{_libexecdir}
install -D -p -m 0755 target/release/virtiofsd %{buildroot}%{_libexecdir}/virtiofsd
install -D -p -m 0644 50-qemu-virtiofsd.json %{buildroot}%{_datadir}/qemu/vhost-user/50-qemu-virtiofsd.json

%files
%license LICENSE-APACHE LICENSE-BSD-3-Clause
%doc README.md
%{_libexecdir}/virtiofsd
%{_datadir}/qemu/vhost-user/50-qemu-virtiofsd.json

%changelog
* Tue Mar 22 2022 Sergio Lopez <slp@redhat.com> - 1.1.0-4
- process_queue_pool-Only-acquire-the-VringMutex-lock-.patch [bz#2057252]
- Set-the-number-of-written-bytes-for-used-descs.patch [bz#2057252]
- Clean-up-flags-in-opendir-downstream.patch [bz#2057252]
- Resolves: bz#2057252
  ([virtiofsd]Can't access to the shared directory on windows guest with the new virtiofsd(rust))

* Fri Feb 18 2022 Sergio Lopez <slp@redhat.com> - 1.1.0-3
- Restore "Provides: virtiofsd", despite rpmdeplint complains, to
  satisfy qemu-kvm dependencies

* Fri Jan 28 2022 Sergio Lopez <slp@redhat.com> - 1.1.0-2
- Explicitly declare the conflict with qemu-virtiofsd
- Remove explicit library dependencies
- Remove useless "Provides: virtiosfd"
- Remove Windows binaries from vendor tarball

* Thu Jan 27 2022 Sergio Lopez <slp@redhat.com> - 1.1.0-1
- Initial package

